---
title: 'Map.prototype[@@iterator]()'
slug: Web/JavaScript/Reference/Global_Objects/Map/@@iterator
tags:
  - ECMAScript 2015
  - Iterator
  - JavaScript
  - Map
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p class="seoSummary">The initial value of the <strong><code>@@iterator</code></strong> property is the same function object as the initial value of the {{jsxref("Map.prototype.entries()", "entries")}} method.</p>

<div>{{EmbedInteractiveExample("pages/js/map-prototype-@@iterator.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>myMap</var>[Symbol.iterator]</pre>

<h3 id="Return_value">Return value</h3>

<p>The map <strong>iterator</strong> function, which is the {{jsxref("Map.prototype.entries()", "entries()")}} function by default.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_iterator">Using [@@iterator]()</h3>

<pre class="brush:js notranslate">const myMap = new Map()
myMap.set('0', 'foo')
myMap.set(1, 'bar')
myMap.set({}, 'baz')

const mapIter = myMap[Symbol.iterator]()

console.log(mapIter.next().value) // ["0", "foo"]
console.log(mapIter.next().value) // [1, "bar"]
console.log(mapIter.next().value) // [Object, "baz"]
</pre>

<h3 id="Using_iterator_with_for..of">Using [@@iterator]() with for..of</h3>

<pre class="brush: js notranslate">const myMap = new Map()
myMap.set('0', 'foo')
myMap.set(1, 'bar')
myMap.set({}, 'baz')

for (const entry of myMap) {
  console.log(entry)
}
// ["0", "foo"]
// [1, "bar"]
// [{}, "baz"]

for (const [key, value] of myMap) {
  console.log(`${key}: ${value}`)
}
// 0: foo
// 1: bar
// [Object]: baz
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-map.prototype-@@iterator', 'Map.prototype[@@iterator]()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Map.@@iterator")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Map.prototype.entries()")}}</li>
 <li>{{jsxref("Map.prototype.keys()")}}</li>
 <li>{{jsxref("Map.prototype.values()")}}</li>
</ul>
